extern AFun symDerive;

static inline ATerm makeDerive(ATermList e1, ATermList e2, ATermList e3, ATerm e4, ATerm e5, ATermList e6, ATermList e7) {
    ATerm array[7] = { (ATerm) e1, (ATerm) e2, (ATerm) e3, e4, e5, (ATerm) e6, (ATerm) e7};
    return (ATerm) ATmakeApplArray(symDerive, array);
}

#ifdef __cplusplus
static inline bool matchDerive(ATerm e, ATermList & e1, ATermList & e2, ATermList & e3, ATerm & e4, ATerm & e5, ATermList & e6, ATermList & e7) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symDerive) return false;
    e1 = (ATermList) ATgetArgument(e, 0);
    e2 = (ATermList) ATgetArgument(e, 1);
    e3 = (ATermList) ATgetArgument(e, 2);
    e4 = ATgetArgument(e, 3);
    if (ATgetType(e4) != AT_APPL) return false;
    e5 = ATgetArgument(e, 4);
    if (ATgetType(e5) != AT_APPL) return false;
    e6 = (ATermList) ATgetArgument(e, 5);
    e7 = (ATermList) ATgetArgument(e, 6);
    return true;
}
#endif


extern AFun symEnvBinding;

static inline ATerm makeEnvBinding(ATerm e1, ATerm e2) {
    return (ATerm) ATmakeAppl2(symEnvBinding, e1, e2);
}

#ifdef __cplusplus
static inline bool matchEnvBinding(ATerm e, ATerm & e1, ATerm & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symEnvBinding) return false;
    e1 = ATgetArgument(e, 0);
    if (ATgetType(e1) != AT_APPL) return false;
    e2 = ATgetArgument(e, 1);
    if (ATgetType(e2) != AT_APPL) return false;
    return true;
}
#endif


extern AFun symDerivationInput;

static inline ATerm makeDerivationInput(ATerm e1, ATermList e2) {
    return (ATerm) ATmakeAppl2(symDerivationInput, e1, (ATerm) e2);
}

#ifdef __cplusplus
static inline bool matchDerivationInput(ATerm e, ATerm & e1, ATermList & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symDerivationInput) return false;
    e1 = ATgetArgument(e, 0);
    if (ATgetType(e1) != AT_APPL) return false;
    e2 = (ATermList) ATgetArgument(e, 1);
    return true;
}
#endif


extern AFun symDerivationOutput;

static inline ATerm makeDerivationOutput(ATerm e1, ATerm e2, ATerm e3, ATerm e4) {
    return (ATerm) ATmakeAppl4(symDerivationOutput, e1, e2, e3, e4);
}

#ifdef __cplusplus
static inline bool matchDerivationOutput(ATerm e, ATerm & e1, ATerm & e2, ATerm & e3, ATerm & e4) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symDerivationOutput) return false;
    e1 = ATgetArgument(e, 0);
    if (ATgetType(e1) != AT_APPL) return false;
    e2 = ATgetArgument(e, 1);
    if (ATgetType(e2) != AT_APPL) return false;
    e3 = ATgetArgument(e, 2);
    if (ATgetType(e3) != AT_APPL) return false;
    e4 = ATgetArgument(e, 3);
    if (ATgetType(e4) != AT_APPL) return false;
    return true;
}
#endif


extern AFun symOldClosure;

static inline ATerm makeOldClosure(ATermList e1, ATermList e2) {
    return (ATerm) ATmakeAppl2(symOldClosure, (ATerm) e1, (ATerm) e2);
}

#ifdef __cplusplus
static inline bool matchOldClosure(ATerm e, ATermList & e1, ATermList & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symOldClosure) return false;
    e1 = (ATermList) ATgetArgument(e, 0);
    e2 = (ATermList) ATgetArgument(e, 1);
    return true;
}
#endif


extern AFun symOldClosureElem;

static inline ATerm makeOldClosureElem(ATerm e1, ATermList e2) {
    return (ATerm) ATmakeAppl2(symOldClosureElem, e1, (ATerm) e2);
}

#ifdef __cplusplus
static inline bool matchOldClosureElem(ATerm e, ATerm & e1, ATermList & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symOldClosureElem) return false;
    e1 = ATgetArgument(e, 0);
    if (ATgetType(e1) != AT_APPL) return false;
    e2 = (ATermList) ATgetArgument(e, 1);
    return true;
}
#endif


void initDerivationsHelpers();

static inline const char * aterm2String(ATerm t) {
    return (const char *) ATgetName(ATgetAFun(t));
}

